// -----------------------------------------------------------------------------
//  CCE_Text.h
//  CdCat2
//
//  Created by Livio Sandel on Mon Jan 12 2004.
//  No Copyright 2004 __MyCompanyName__. 
//
// Interface file for drawing a string

#import <Foundation/Foundation.h>

#import "CCE_BasicForm.h"

@interface CCE_Text : CCE_BasicForm {
	// la classe che contiene il testo
	NSTextStorage   *textStorage;
	// punto di visualizzazione
	NSPoint			drawPoint ;
	float			rotAngle ;
}
// i soliti metodi comuni
- (id) initWithTextStorage: (NSTextStorage *) theText atPoint: (NSPoint) aPoint andRotation: (float) angle ;
- (void) dealloc ;
- (void) drawElement: (NSRect) inRect ;

// accessor
- (NSTextStorage *)textStorage;
- (void)setTextStorage:(NSTextStorage *)newTextStorage;

@end
