//
//  CdCatDoc.h
//  CdCat2
//
//  Created by Livio Sandel on Sat Dec 27 2003.
//  Copyright (c) 2003 DjZero00Soft. All rights reserved.
//


#import <Cocoa/Cocoa.h>

#import "CatDataSrc.h"
#import "VolInfo.h"
#import "CoverWinCtl.h"
#import "ListWinCtl.h"

@interface CdCatDoc : NSDocument
{
	// dati presenti nel file
	NSData		* dataFromFile ;
	// la 'sorgente dei dati'
	CatDataSrc  * dataSource ;
	// le due finestre associate al documento
	ListWinCtl		* listWin  ;
	CoverWinCtl		* coverWin ;
}
- (void) windowControllerDidLoadNib:(NSWindowController *) aController ;
- (void) addVolume2Cat: (NSWindow *)sheet returnCode: (int)returnCode contextInfo: (void *)contextInfo ;
- (void) performAddFilesModal: ( NSArray *)volList  ;
- (void) loadCatalogWithData: (NSData *) data ;

- (void) refreshWinsWithListSts: (NSString*) sts1Bar coverSts: (NSString*) sts2Bar ;
- (void) showCoversWindow ;

- (CatDataSrc*)dataSource;
- (void)setDataSource:(CatDataSrc*)newDataSource;
- (NSData *)dataFromFile;
- (void)setDataFromFile:(NSData *)newDataFromFile;
- (CoverWinCtl *)coverWin ;
- (void)setCoverWin:(CoverWinCtl *)newCoverWin;

@end
