#import "CoverView.h"

#import "ImageAndTextCell.h"
#import "CatFileInfo.h"
#import "CatDataSrc.h"
#import "CoverWinCtl.h"
#import "CoverPalWinCtl.h"

@implementation CoverView

// --------------------------------------------------------------------- 
- (id)initWithFrame:(NSRect)frameRect
{
	float   x1, x2, y1, y2 ;

	if ((self = [super initWithFrame:frameRect]) != nil) 
	{
		// costruisco il vettore degli elementi
		[ self setTheElements: [[CCE_ElemGroup alloc] init ] ];
		[ self setCurCreatingElem: nil ] ;
		[ self setCurSelectRect: nil ] ;
		// aggiungo un po' di roba
		if ( 1 )
		{   // qui disegno tutto lo sfondo della copertina
			CCE_Line		* tmpLine ;
			CCE_Rect		* tmpRect ;

			// due linee di taglio inferiori verticali
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST ;
			y1 = STARTPOINT_Y ;
			x2 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ NSColor redColor] ];
			[ tmpLine setCceLineWidth: 0 ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM ;
			y1 = STARTPOINT_Y ;
			x2 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ NSColor redColor] ];
			[ tmpLine setCceLineWidth: 0 ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			// due linee di taglio inferiori orizzontali
			x1 = STARTPOINT_X ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST ;
			x2 = STARTPOINT_X + CUTSIGN_DIM ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ NSColor redColor] ];
			[ tmpLine setCceLineWidth: 0 ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM + CUTSIGN_DIST ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST ;
			x2 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM + CUTSIGN_DIST + CUTSIGN_DIM ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ NSColor redColor] ];
			[ tmpLine setCceLineWidth: 0 ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			// due linee di taglio superiori veritcali
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM + CUTSIGN_DIST ;
			x2 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM + CUTSIGN_DIST + CUTSIGN_DIM ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ NSColor redColor] ];
			[ tmpLine setCceLineWidth: 0 ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM + CUTSIGN_DIST ;
			x2 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM + CUTSIGN_DIST + CUTSIGN_DIM ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ NSColor redColor] ];
			[ tmpLine setCceLineWidth: 0 ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			// due linee di taglio superiori orizzontali
			x1 = STARTPOINT_X ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM ;
			x2 = STARTPOINT_X + CUTSIGN_DIM ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineWidth: 0 ];
			[ tmpLine setCceLineColor: [ NSColor redColor] ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM + CUTSIGN_DIST ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM ;
			x2 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM + CUTSIGN_DIST + CUTSIGN_DIM ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ NSColor redColor] ];
			[ tmpLine setCceLineWidth: 0 ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			// rettangolo completo in nero
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST ;
			x2 = BACK_OUTER_HOR_DIM ;
			y2 = BACK_OUTER_VER_DIM ;	
			tmpRect = [ [ CCE_Rect alloc] initWithRect: NSMakeRect(CM2PX(x1), CM2PX(y1), CM2PX(x2), CM2PX(y2)) ];
			[ tmpRect setCceLineWidth: 1 ];
			[ tmpRect setCceLineColor: [ NSColor blackColor] ];
			[ tmpRect setCceIsStroked: TRUE ];
			[ tmpRect setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpRect ];
			// le due linee per le barre laterali del titolo
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_LABEL_HOR_DIM ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST ;
			x2 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_LABEL_HOR_DIM ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineWidth: 1 ];
			[ tmpLine setCceLineColor: [ NSColor blackColor] ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM - BACK_LABEL_HOR_DIM ;
			y1 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST ;
			x2 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM - BACK_LABEL_HOR_DIM ;
			y2 = STARTPOINT_Y + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_VER_DIM ;	
			tmpLine = [ [ CCE_Line alloc] initStartPt: NSMakePoint( CM2PX(x1), CM2PX(y1) )
										toPt: NSMakePoint( CM2PX(x2), CM2PX(y2) ) ] ;
			[ tmpLine setCceLineColor: [ NSColor blackColor] ];
			[ tmpLine setCceLineWidth: 1 ];
			[ tmpLine setCceIsLocked: NO ];
			[ [self theElements] addElem: tmpLine ];
		}
		if ( 0 )
		{   // aggiungo il testo orizzontale
			NSLayoutManager *layoutManager;
			NSTextContainer *textContainer;
			NSFont			* locFont ;
			NSRange			myrange ;
			NSTextStorage   * loctextStorage ;
			CCE_Text		* tmpText ;
			// predispongo le istanze ausiliarie
			loctextStorage = [[NSTextStorage alloc] initWithString:@"back cover"];
			layoutManager = [[[NSLayoutManager alloc] init] autorelease ];
			textContainer = [[[NSTextContainer alloc] init] autorelease ];
			// imposto gli attributi per tutto il range
			myrange = NSMakeRange(0, [ loctextStorage length] ) ;
			locFont = [ NSFont fontWithName: @"Arial" size: 16 ] ;
			// assegno font e colore del testo		
			[ loctextStorage addAttribute: NSFontAttributeName value: locFont range: myrange ];
			[ loctextStorage addAttribute: NSForegroundColorAttributeName value: [NSColor greenColor] range: myrange ];

			[layoutManager addTextContainer:textContainer];
			[layoutManager setUsesScreenFonts:NO];
			[loctextStorage addLayoutManager:layoutManager];
			// calcolo il punto
			x1 = STARTPOINT_X + CUTSIGN_DIM + CUTSIGN_DIST + BACK_OUTER_HOR_DIM / 2 ;
			y1 = STARTPOINT_Y + CUTSIGN_DIST ;
			tmpText = [[ CCE_Text alloc] initWithTextStorage: loctextStorage
					atPoint: NSMakePoint(CM2PX(x1), CM2PX(y1)) andRotation: 0.0 ];
			// aggiungo l'elemento al vettore
			[ [self theElements] addElem: tmpText ];
		}
	}
	return self;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void) dealloc 
{
	[ theElements dealloc ];
    [ super dealloc ];
}
// --------------------------------------------------------------------- 
// per rovesciare l'asse delle ordinate
- (BOOL)isFlipped {
    return YES;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (BOOL)
acceptsFirstMouse:(NSEvent *)theEvent
{
    return YES;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
setZoom:(float)scaleFactor 
{
    NSRect frame = [self frame];
    NSRect bounds = [self bounds];
    frame.size.width = bounds.size.width * scaleFactor;
    frame.size.height = bounds.size.height * scaleFactor;
    [self setFrameSize: frame.size];    
    [self setBoundsSize: bounds.size]; 
}

// --------------------------------------------------------------------- 
// il disegno della vista 
- (void)drawRect:(NSRect)rect
{
	// sfondo bianco
	[[ NSColor whiteColor] set ];
	NSRectFill( rect );
	// poi dico di disegnarsi a tutti gli elementi
	[ [self theElements] drawElement: rect ];
	// e poi all'elemento in corso
	if ( curCreatingElem )
	{
		[ curCreatingElem drawElement: rect ] ;
	}
	if ( curSelectRect )
	{
		NSBezierPath	* curPath = [ curSelectRect theRect ];
		float			strokePattern[2] ={ 5, 5 } ;
		[ curPath setLineDash: strokePattern count: 2 phase: 0.0];
		[ curSelectRect setTheRect: curPath ];
		[ curSelectRect drawElement: rect ] ;
	}
}

// --------------------------------------------------------------------- 
- (void)keyDown:(NSEvent *)event 
{
     [self interpretKeyEvents:[NSArray arrayWithObject:event]];
}

// binding per la quattro frecce
- (void)moveLeft:(id)sender {
    [ theElements moveSelectedElements: NSMakePoint(-1.0, 0.0)];
	[ self setNeedsDisplay: YES ];
}

- (void)moveRight:(id)sender {
    [ theElements moveSelectedElements: NSMakePoint(1.0, 0.0)];
	[ self setNeedsDisplay: YES ];
}

- (void)moveUp:(id)sender {
    [ theElements moveSelectedElements: NSMakePoint(0.0, -1.0)];
	[ self setNeedsDisplay: YES ];
}

- (void)moveDown:(id)sender {
    [ theElements moveSelectedElements: NSMakePoint(0.0, 1.0)];
	[ self setNeedsDisplay: YES ];
}

// binding per la quattro frecce con tasto maiuscole
- (void)moveLeftAndModifySelection:(id)sender {
    [ theElements moveSelectedElements: NSMakePoint(-10.0, 0.0)];
	[ self setNeedsDisplay: YES ];
}

- (void)moveRightAndModifySelection:(id)sender {
    [ theElements moveSelectedElements: NSMakePoint(10.0, 0.0)];
	[ self setNeedsDisplay: YES ];
}

- (void)moveUpAndModifySelection:(id)sender {
    [ theElements moveSelectedElements: NSMakePoint(0.0, -10.0)];
	[ self setNeedsDisplay: YES ];
}

- (void)moveDownAndModifySelection:(id)sender {
    [ theElements moveSelectedElements: NSMakePoint(0.0, 10.0)];
	[ self setNeedsDisplay: YES ];
}

// --------------------------------------------------------------------- 
// gestione di un evento di click del mouse
- (void)
mouseDown:(NSEvent *)theEvent 
{
	// vado a pigliare qual e' il tool correntemente selezionato nella finestra
    Class selCls = [[CoverPalWinCtl sharedCoverPalWinCtrl] getCurrClassTool];
	// se e' selezionato un elemento da disegnare
    if (selCls) 
	{
		// costruisco l'elemento grafico
		CCE_BasicForm   * curElem = [[ [selCls alloc ] init] autorelease ] ;
		// metto a posto un di attributi base dell'elemento
		[ curElem  setCceLineWidth: [[CoverPalWinCtl sharedCoverPalWinCtrl] getLineWidth] ];
		[ curElem  setCceFillColor: [[CoverPalWinCtl sharedCoverPalWinCtrl] getCurrFillColor] ];
		[ curElem  setCceLineColor: [[CoverPalWinCtl sharedCoverPalWinCtrl] getCurrLineColor] ];
		[ curElem  setCceIsFilled:  [[CoverPalWinCtl sharedCoverPalWinCtrl] getFillSts] ];
		[ curElem  setCceIsStroked: [[CoverPalWinCtl sharedCoverPalWinCtrl] getStrokeSts] ];
		// deseleziono tutto
		[ theElements cascadeSelection: NO ] ;				
		// dico che l'elemento che sto disegnando e' selezionato
		[ curElem  setCceIsSelected: YES ];
		// e che si tratta dell'elemento in lavorazione
		[ self setCurCreatingElem: curElem ] ;
		// gestisco la costruzione col mouse
		if ([curElem handleCreation: theEvent inView: self ]) 
		{
			// se la creazione e' andata a buon fine,lo aggiungo alla lista
			[theElements addElem:curElem ];
		}
		// non ci sono piu' elementi in lavorazione
		[ self setCurCreatingElem: nil ] ;
	}
	else 
	{
		// non si deve disegnare un nuovo elemento
		// tratto un generico click all'interno della finestra
		[self handleMouseClick: theEvent];
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// tratto un generico click all'interno della finestra
- (void)
handleMouseClick: (NSEvent *)theEvent 
{
    NSPoint			whereClick;
	CCE_BasicForm   * curElem = nil;
    BOOL			shiftKeyPress = (([theEvent modifierFlags] & NSShiftKeyMask) ? YES : NO);
	// vado a vedere dove e' avvenuto il click
    whereClick = [self convertPoint:[theEvent locationInWindow] fromView:nil];
	// niente niente l'utente vuole selezionare un elemento
    curElem = [self getClickedElem:whereClick];
	// potrebbe aver fatto clic su uno degli hangle
	// se c'e' un elemento sotto il mouse
	if ( curElem )
	{
		short   clicInHandle = [ curElem clicIntoHandle: whereClick ] ;
		// abbiamo qualcosa sotto il mouse
		// vedo se e' gia' selezionato
		if ( [ curElem cceIsSelected ] )
		{
				if ( shiftKeyPress )
				{
					// lo tolgo dagli elementi selezionati
					[ curElem setCceIsSelected: NO ];
				}
				else
				{
					// provo a vedere se e' il caso di muoverlo
					if ( clicInHandle == -1 )
						[ self handleMoveAll: theEvent ];
					else [ curElem handleResize: theEvent inView: self movingHandle: clicInHandle ];
				}
		}
		else
		{
			if ( ! shiftKeyPress )
			{
				// deseleziono tutto
				[ theElements cascadeSelection: NO ] ;				
			}
			// seleziono questo elemento
			[ curElem  setCceIsSelected: YES ];
			// ridisegno tutto che la vista e' cambiata...
			[ self setNeedsDisplay: YES ];
			// provo a vedere se e' il caso di muoverlo
			if ( clicInHandle == -1 )
				[ self handleMoveAll: theEvent ];
			else [ curElem handleResize: theEvent inView: self movingHandle: clicInHandle ]; 
		}
	}
	else
	{
		int		i , numElem ;
		CCE_BasicForm   * elem ;
		NSRect selRect ;
		// comincio la selezione multipla
		selRect = [ self handleRectSelect: theEvent ];
		
		// ciclo su tutti gli elementi del gruppo
		numElem = [ [ theElements elemArray] count ];
		for ( i = 0 ; i < numElem ; i ++ )
		{
			elem = [ [ theElements elemArray] objectAtIndex: i ];
			[ elem selectMeIfInRect: selRect addingToSelez: shiftKeyPress] ;
		}
	}
	// ridisegno tutto, in ogni caso
	[ self setNeedsDisplay: YES ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
handleMoveAll: (NSEvent *)theEvent 
{
	// recupero la coordinata locale
    NSPoint point1 = [self convertPoint:[theEvent locationInWindow] fromView:nil];
	NSPoint point2 ;

	// ciclo piu' o meno lungo di attesa eventi
	do  {
		// recupero il prossimo evento, che sia un movimento del mouse 
		// oppure un mouseup (che finisce il tutto)
		theEvent = [[self window] nextEventMatchingMask:(NSLeftMouseDraggedMask | NSLeftMouseUpMask)];  
		// recupero la coordinata locale
		point2 = [self convertPoint:[theEvent locationInWindow] fromView:nil];
		// aggiusto l'aspetto dell'oggetto
		[ theElements moveSelectedElements: NSMakePoint(point2.x-point1.x,point2.y-point1.y)];
		// il nuovo punto di partenza
		point1 = point2 ;
		// forzo un ridisegno della finestra
		[ self setNeedsDisplay: YES ];
	}
	while ( [theEvent type] != NSLeftMouseUp) ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (NSRect)
handleRectSelect: (NSEvent *)theEvent
{
	NSRect		selRect = NSMakeRect(1, 1, 0, 0);
	// costruisco l'elemento grafico
	CCE_Rect   * curElem = [[ [CCE_Rect alloc ] init] autorelease ] ;
    BOOL shiftKeyPress = (([theEvent modifierFlags] & NSShiftKeyMask) ? YES : NO);
	// metto a posto un di attributi base dell'elemento
	[ curElem  setCceLineWidth: 0.0F ];
	[ curElem  setCceLineColor: [NSColor blackColor]  ];
	[ curElem  setCceFillColor: [NSColor lightGrayColor] ];
	[ curElem  setCceIsFilled:  NO ];
	[ curElem  setCceIsStroked: YES ];
	if ( ! shiftKeyPress )
	{
		// deseleziono tutto
		[ theElements cascadeSelection: NO ] ;				
	}
	// dico che l'elemento che sto disegnando e' selezionato
	[ curElem  setCceIsSelected: NO ];
	[ self setCurSelectRect: curElem ] ;
	// gestisco la costruzione col mouse
	[curElem handleCreation: theEvent inView: self ] ;
	selRect = [ curElem elemLimit] ;
	[ self setCurSelectRect: nil ] ;
	return ( selRect );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// vado a vedere se il click e' avvenuto su di un elemento
- (CCE_BasicForm *)
getClickedElem:(NSPoint)point 
{
	int				i , numElem ;
	CCE_BasicForm   * elem ;
	NSMutableArray		* listaelem ;
	// esamino tutti gli elemento
	listaelem = [ theElements elemArray ];
	numElem = [ listaelem count ];
	for ( i = 0 ; i < numElem ; i ++ )
	{
		elem = [ listaelem objectAtIndex: i ];
		// e controllo se il click gli appartiene
        if ( [ elem checkClickOnMe: point ]) 
		{
			// ho finito, esco dal ciclo
            break;
		}
		// controllo un eventuale click su handle
		if ( [ elem clicIntoHandle: point] != -1 )
			break ;
	}
	// potrei non avere trovato nulla
	if ( i == numElem )
		return ( nil );
	// se arrivo qui, ho trovato un elemento
	return ( elem );
}
// --------------------------------------------------------------------- 

- (void)
executeAlignment: (int) menuTag
{
	NSMutableArray  * selArr ;
	int		numElem, i ;
	float   curTop, newTop, delta ;
	CCE_BasicForm   * elem ;
	BOOL	chooseDir  ;
	SEL		getDim  ;

	switch ( menuTag ) {
	case 1 : chooseDir = TRUE ; getDim = @selector(getElemLeft) ; break ;
	case 2 : chooseDir = FALSE ; getDim = @selector(getElemRight) ; break ;
	case 3 : chooseDir = TRUE ; getDim = @selector(getElemTop) ; break ;
	case 4 : chooseDir = FALSE ; getDim = @selector(getElemBottom) ; break ;
	default : return ;
	}
	selArr = [ theElements getSelectedGraphics ];
	numElem = [ selArr count ];
	elem = [ selArr objectAtIndex: 0 ];
	curTop =  [[ elem performSelector: getDim ] floatValue ];
	for ( i = 1 ; i < numElem ; i ++ )
	{
		elem = [ selArr objectAtIndex: i ];
		newTop = [[ elem performSelector: getDim ] floatValue ];
		if ( chooseDir && newTop < curTop )
			curTop = newTop ;
		else if ( ! chooseDir && newTop > curTop )
			curTop = newTop ;
	}
	// adesso che ho il top, sposto tutto
	for ( i = 0 ; i < numElem ; i ++ )
	{
		elem = [ selArr objectAtIndex: i ];
		delta = curTop - [[ elem performSelector: getDim ] floatValue ];
		if ( menuTag == 1 || menuTag == 2 )
				[ elem moveMeIfSelectBy: NSMakePoint( delta, 0 )];
		else	[ elem moveMeIfSelectBy: NSMakePoint( 0, delta )];
	}
	[ self setNeedsDisplay: YES ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void)
executeCentering: (int) menuTag
{
	NSMutableArray  * selArr ;
	int		numElem, i ;
	float   curMax, curMin, curMid, newTop, delta ;
	CCE_BasicForm   * elem ;
	SEL		getDim  ;
	// middle: centro le ordinate, center: centro le ascisse
	switch ( menuTag ) {
	case 5 : getDim = @selector(getElemMiddle) ; break ;
	case 6 : getDim = @selector(getElemCenter) ; break ;
	default : return ;
	}
	selArr = [ theElements getSelectedGraphics ];
	numElem = [ selArr count ];
	elem = [ selArr objectAtIndex: 0 ];
	curMax = curMin =  [[ elem performSelector: getDim ] floatValue ];
	for ( i = 1 ; i < numElem ; i ++ )
	{
		elem = [ selArr objectAtIndex: i ];
		newTop = [[ elem performSelector: getDim ] floatValue ];
		if ( newTop < curMin )
			curMin = newTop ;
		else if ( newTop > curMax )
			curMax = newTop ;
	}
	// adesso che ho il max ed il min, sposto tutto
	curMid = 0.5 * (curMax + curMin );
	for ( i = 0 ; i < numElem ; i ++ )
	{
		elem = [ selArr objectAtIndex: i ];
		delta = curMid - [[ elem performSelector: getDim ] floatValue ];
		if ( menuTag == 6 )
				[ elem moveMeIfSelectBy: NSMakePoint( delta, 0 )];
		else	[ elem moveMeIfSelectBy: NSMakePoint( 0, delta )];
	}
	[ self setNeedsDisplay: YES ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void) 
elemAlign: (id)sender 
{
	int		menuTag = [ sender tag ];
	[ self executeAlignment: menuTag ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void) 
groupElem: (id)sender 
{
	int		menuTag = [ sender tag ];

	if ( menuTag == 200 )
	{
		[ theElements makeGroupFromSelected ];
	}
	else
	{
		NSMutableArray  * selArr ;
		int		numElem, i ;
		CCE_BasicForm   * elem ;
	
		selArr = [ theElements elemArray ];
		numElem = [ selArr count ];
		for ( i = numElem-1 ; i >= 0; i -- )
		{
			elem = [ selArr objectAtIndex: i ];
			if ( ! [ elem cceIsSelected ])
				continue ;
			// se arrivo qui, l'elemento e' selezionato
			// ma potrebbe non essere un gruppo
			if ( ! [elem isKindOfClass:[CCE_ElemGroup class]] )
				continue ;
			// se arrivo qui, l'elemento e' selezionato ed e' un gruppo
			[ elem retain ];
			// lo elimino dall'insieme degli oggetti
			[ [theElements elemArray] removeObjectAtIndex: i ];
			// e poi appiccico gli elementi
			[ ((CCE_ElemGroup*) elem) ungroupAndInsertIn: theElements startingFrom: i ];
			[ elem release ];
		}
	}
	[ self setNeedsDisplay: YES ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void) 
lockElems: (id)sender 
{
	NSMutableArray  * selArr ;
	int		numElem, i ;
	CCE_BasicForm   * elem ;
	int		menuTag = [ sender tag ];

	selArr = [ theElements getSelectedGraphics ];
	numElem = [ selArr count ];
	for ( i = 0 ; i < numElem ; i ++ )
	{
		elem = [ selArr objectAtIndex: i ];
		if ( menuTag == 100 )
				[ elem setCceIsLocked: YES ];
		else	[ elem setCceIsLocked: NO ];
	}
	[ self setNeedsDisplay: YES ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- (void) 
sendElemFB: (id)sender 
{
	int		menuTag = [ sender tag ];
	switch ( menuTag ) {
	case 1 : [ theElements sendElemFrontAndBack: +2 ]; break ;
	case 2 : [ theElements sendElemFrontAndBack: +1 ]; break ;
	case 3 : [ theElements sendElemFrontAndBack: -1 ]; break ;
	case 4 : [ theElements sendElemFrontAndBack: -2 ]; break ;
	default :
		return ;
	}
	[ self setNeedsDisplay: YES ];
}

// --------------------------------------------------------------------- 
// accessor
- (CoverWinCtl *)winCtl {
    return  winCtl ;
}

- (void)setWinCtl:(CoverWinCtl *)newWinCtl {
    if (winCtl != newWinCtl) {
        [winCtl release];
        winCtl = [newWinCtl retain];
    }
}

- (NSOutlineView *)catView {
    return  catView ;
}

- (void)setCatView:(NSOutlineView *)newCatView {
    if (catView != newCatView) {
        [catView release];
        catView = [newCatView retain];
    }
}

- (CCE_ElemGroup *)theElements {
    return [[theElements retain] autorelease];
}

- (void)setTheElements:(CCE_ElemGroup *)newTheElements {
    if (theElements != newTheElements) {
        [theElements release];
        theElements = [newTheElements retain];
    }
}

- (CCE_BasicForm *)curCreatingElem {
    return curCreatingElem ;
}

- (void)setCurCreatingElem:(CCE_BasicForm *)newCurCreatingElem {
    if (curCreatingElem != newCurCreatingElem) {
        [curCreatingElem release];
        curCreatingElem = [newCurCreatingElem retain];
    }
}

- (CCE_Rect *)curSelectRect {
    return curSelectRect ;
}

- (void)setCurSelectRect:(CCE_Rect *)newCurSelectRect {
    if (curSelectRect != newCurSelectRect) {
        [curSelectRect release];
        curSelectRect = [newCurSelectRect retain];
    }
}

@end
