/* ListWinCtl */

#import <Cocoa/Cocoa.h>

@interface ListWinCtl : NSWindowController
{
    IBOutlet NSOutlineView *fullList;
    IBOutlet NSTextField *statusBar;
}
// metodi per la gestione della toolbar
- (void)  addToolbarToWin: (NSWindow *) currWin ;
- (NSToolbarItem *) toolbar: (NSToolbar *)t itemForItemIdentifier: (NSString *) i willBeInsertedIntoToolbar:(BOOL) w ;
- (NSArray *) toolbarDefaultItemIdentifiers: (NSToolbar *) toolbar ;
- (NSArray *) toolbarAllowedItemIdentifiers: (NSToolbar *) toolbar ;
- (void) toolbarWillAddItem: (NSNotification *) notif ;
- (BOOL) validateToolbarItem: (NSToolbarItem *) toolbarItem ;

- (void) windowDidLoad ;

// aggiunta di un elemento al catalogo
- (void) addFileItem: (id)sender ;
// rimozione di un elemento dal catalogo
- (void) delItem: (id)sender ;
- (void) prefsUpdated: ( NSNotification *) notification ;

- (void) refreshWindow ;
- (void) setStsStrings: (NSString *) sts1Val andSts: (NSString *) st2Val;
- (id) getMainView ;

@end
