// ObjMakerWinCtl.h
// Sketch Example
//

#import <AppKit/AppKit.h>

@class CoverView;

@interface ObjMakerWinCtl : NSWindowController {
    IBOutlet NSButton		* fillCheckbox;
    IBOutlet NSColorWell	* fillColorWell;
    IBOutlet NSButton		* lineCheckbox;
    IBOutlet NSColorWell	* lineColorWell;
    IBOutlet NSSlider		* lineWidthSlider;
    IBOutlet NSTextField	* lineWidthTextField;
    IBOutlet NSTextField	* xTextField;
    IBOutlet NSTextField	* yTextField;
    IBOutlet NSTextField	* widthTextField;
    IBOutlet NSTextField	* heightTextField;
    IBOutlet NSPopUpButton	* classSelection;
	// puntatore alla view della finestra dove si disegna
	CoverView				* theDrawView ;
    IBOutlet NSButton		* createButton;
}

+ (id)sharedObjMakerWinCtl;

- (IBAction)createObject:(id)sender;

- (void) setMainWindow: (NSWindow *) mainWindow ;
- (void)mainWindowChanged:(NSNotification *)notification ;
- (void)mainWindowResigned:(NSNotification *)notification ;
@end
