// -----------------------------------------------------------------------------
//  CCE_ElemGroup.h
//  CdCat2
//
//  Created by Livio Sandel on Mon Jan 12 2004.
//  No Copyright 2004 __MyCompanyName__. 
//
// Interface file for a group of element

#import <Foundation/Foundation.h>

#import "CCE_BasicForm.h"
#import "CCE_Line.h"
#import "CCE_Rect.h"
#import "CCE_Text.h"
#import "CCE_Circle.h"

@interface CCE_ElemGroup : CCE_BasicForm {
	// il vettore degli elementi raggruppati
	NSMutableArray		* elemArray ;
}
// i soliti metodi comuni
- (id) init ;
- (void) dealloc ;
- (void) drawElement: (NSRect) inRect ;

// per aggiungere un elemento al gruppo
- (void) addElem: (CCE_BasicForm *) elem ;
- (void) cascadeSelection:(BOOL)newIsSelected ;

- (void) selectElemsInRect: (NSRect) selRect addingToSelez: (BOOL) add2sel ;

- (void ) sendElemFrontAndBack: (int) howMuch;
- (void) moveSelectedElements: (NSPoint) distance ;

- (NSMutableArray *) getSelectedGraphics;
- (void ) ungroupAndInsertIn: (CCE_ElemGroup *) masterArray startingFrom: (int) idx ;
- (void) makeGroupFromSelected ;

// accessor
- (NSMutableArray *)elemArray;
- (void)setElemArray:(NSMutableArray *)newElemArray;

@end
