// -----------------------------------------------------------------------------
//  CCE_Line.h
//  CdCat2
//
//  Created by Livio Sandel on Mon Jan 12 2004.
//  No Copyright 2004 __MyCompanyName__. 
//
// Interface file for drawing a simple line

#import <Foundation/Foundation.h>

#import "CCE_BasicForm.h"

@interface CCE_Line : CCE_BasicForm {
	// punto di inizio
	NSPoint			startPoint ;
	// punto di terminazione
	NSPoint			endPoint ;
	// tengo il percorso per meglio disegnare
	NSBezierPath	* theLine ;
	// variabile di appoggio per evitare calcoli
	float			delta ;
}
// i soliti metodi comuni
- (id)   initStartPt: (NSPoint) stPt toPt: (NSPoint) endPt ;
- (void) dealloc ;
- (void) drawElement: (NSRect) inRect ;

// accessor
- (NSBezierPath *)theLine;
- (void)setTheLine:(NSBezierPath *)newTheLine;

@end
