/* CoverPalWinCtl */

#import <Cocoa/Cocoa.h>

@interface CoverPalWinCtl : NSWindowController
{
	// elemento grafico corrente
	Class						currCCE ;
	// elementi dell'interfaccia
	IBOutlet NSMatrix			* toolMatrix ;
	IBOutlet NSColorWell		* currLineWell ;
	IBOutlet NSColorWell		* currFillWell ;
    IBOutlet NSButton			* fillCheckbox;
    IBOutlet NSButton			* lineCheckbox;
    IBOutlet NSPopUpButton		* lineWidth;
}
+ ( id ) sharedCoverPalWinCtrl ;
- (IBAction)handleToolSel:(id)sender;
- (NSColor*) getCurrLineColor ;
- (NSColor*) getCurrFillColor ;
- (Class) getCurrClassTool ;
- (BOOL) getStrokeSts ;
- (BOOL) getFillSts ;
- (float) getLineWidth ;
@end
