// -----------------------------------------------------------------------------
//  CoverWinCtl.h
//  CdCat2
//
//  Created by Livio Sandel on Mon Dec 29 2003.
//  No Copyright 2003 __MyCompanyName__. 
//
// Interface file for the window controller

#import <Cocoa/Cocoa.h>


#import "CoverView.h"

@interface CoverWinCtl : NSWindowController
{
    IBOutlet CoverView		* cvrView;
    IBOutlet NSTableView	* volList;
    IBOutlet NSSlider		* zoomSlider;
    IBOutlet NSTextField	* zoomValue;
}
- (void) setMaxSlider: (id)sender ;
- (void) setMinslider: (id)sender ;
- (void) updateZoom: (id)sender ;

- (void) clicBtn01: (id)sender ;
- (void) clicBtn02: (id)sender ;
- (void) clicBtn03: (id)sender ;


- (void) prefsUpdated: ( NSNotification *) notification ;

- (void) windowDidLoad ;

- (void) refreshWindow ;
- (void) setStsStrings: (NSString *) sts1Val andSts: (NSString *) st2Val;
- (id) getMainView ;
- (BOOL)windowShouldClose:(id)sender ;
- (CoverView *)cvrView;
- (void)setCvrView:(CoverView *)newCvrView;

@end
