// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  LocalFormatters.h
//  Created by djzero00 -- Copyright (c) 2002
//
// Interfaccia delle classi formatter

#import <Foundation/Foundation.h>

// classe TOS9TCForm per convertire un OSType in una stringa sensata
@interface TOS9TCForm : NSFormatter 
{
	// niente variabili
}
- (NSString *)stringForObjectValue:(id)anObject ;
- (BOOL)getObjectValue:(id *)anObject forString:(NSString *)string errorDescription:(NSString **)error ; 
- (NSAttributedString *)attributedStringForObjectValue:(id)anObject withDefaultAttributes:(NSDictionary *)attributes ;

@end

// classe FileSizeForm per rappresentare una dimensione in byte in modo interessante
@interface FileSizeForm : NSFormatter 
{
	// niente variabili
}
- (NSString *)stringForObjectValue:(id)anObject ;
- (BOOL)getObjectValue:(id *)anObject forString:(NSString *)string errorDescription:(NSString **)error ; 
- (NSAttributedString *)attributedStringForObjectValue:(id)anObject withDefaultAttributes:(NSDictionary *)attributes ;

@end

// classe FilePosixPerm per rappresentare i permessi posix di lettura/scrittura
@interface FilePosixPerm : NSFormatter 
{
	// niente variabili
}
- (NSString *)stringForObjectValue:(id)anObject ;
- (BOOL)getObjectValue:(id *)anObject forString:(NSString *)string errorDescription:(NSString **)error ; 
- (NSAttributedString *)attributedStringForObjectValue:(id)anObject withDefaultAttributes:(NSDictionary *)attributes ;

@end
